unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, math, ExtDlgs;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    OpenPictureDialog1: TOpenPictureDialog;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Image1: TImage;
    Shape1: TShape;
    Button2: TButton;
    Button3: TButton;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image6: TImage;
    GroupBox3: TGroupBox;
    Button5: TButton;
    Button4: TButton;
    Image5: TImage;
    Button1: TButton;
    Shape2: TShape;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure GroupBox2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type
    pRGBArray  =  ^TRGBArray;
    TRGBArray  =  ARRAY[0..32767] OF TRGBTriple;

var
  Form1: TForm1;
  bx,by:integer;
  
  mx,my:integer;
  mg:boolean;

implementation

{$R *.DFM}


procedure TForm1.Image1Click(Sender: TObject);
begin
if OpenPictureDialog1.Execute then begin
 image1.Picture.LoadFromFile(OpenPictureDialog1.FileName);

 Shape1.Left:=-100;
 Shape2.Left:=-100;
 Image2.Width:=Image1.Width;
 Image2.Height:=Image1.Height;
 Image2.Picture.Bitmap.Width:=Image1.Width;
 Image2.Picture.Bitmap.Height:=Image1.Height;
 Image3.Left:=Image2.Width +Image2.Left +10;
 Image3.Width:=Image2.Width;
 Image3.Height:=Image2.Height;
 Image4.Top:=Image2.Height +Image2.Top +10;
 Image4.Width:=Image2.Width;
 Image4.Height:=Image2.Height;
 Image6.Left:=Image3.Left;
 Image6.Top:=Image4.Top;
 Image6.Width:=Image2.Width;
 Image6.Height:=Image2.Height;
 if Image3.Width+ Image3.Left +15 > Button3.Left + Button3.Width +15 then
  GroupBox1.Width:= Image3.Width+ Image3.Left +15
 else GroupBox1.Width:=Button3.Left + Button3.Width +15;
 GroupBox1.Height:= Image4.Height+ Image4.Top +15;

 Image5.Width:=Image2.Width;
 Image5.Height:=Image2.Height;
 if Image5.Height + Image5.top +15> Button4.Height+Button4.top+15 then
  GroupBox3.Height:=Image5.Height + Image5.top +15
 else GroupBox3.Height:= Button4.Height+Button4.top+15;
 GroupBox3.Width:=Image5.Width + Image5.left +15;
 GroupBox3.Top:= GroupBox1.Height + GroupBox1.Top +10;

 Form1.Width:= GroupBox1.Width+ GroupBox1.Left +15;
 Form1.Height:= GroupBox3.Height+ GroupBox3.top +55;
 end;
end;



procedure TForm1.FormCreate(Sender: TObject);
begin
Image1.Picture.Bitmap.PixelFormat:=pf24bit;
Image2.Picture.Bitmap.PixelFormat:=pf24bit;

Shape1.Left:=-100;
Image2.Width:=Image1.Width;
Image2.Height:=Image1.Height;
Image2.Picture.Bitmap.Width:=Image1.Width;
Image2.Picture.Bitmap.Height:=Image1.Height;
Image3.Left:=Image2.Width +Image2.Left +10;
Image3.Width:=Image2.Width;
Image3.Height:=Image2.Height;
Image4.Top:=Image2.Height +Image2.Top +10;
Image4.Width:=Image2.Width;
Image4.Height:=Image2.Height;
Image6.Left:=Image3.Left;
Image6.Top:=Image4.Top;
Image6.Width:=Image2.Width;
Image6.Height:=Image2.Height;
if Image3.Width+ Image3.Left +15 > Button3.Left + Button3.Width +15 then
  GroupBox1.Width:= Image3.Width+ Image3.Left +15
else GroupBox1.Width:=Button3.Left + Button3.Width +15;
GroupBox1.Height:= Image4.Height+ Image4.Top +15;

Image5.Width:=Image2.Width;
Image5.Height:=Image2.Height;
if Image5.Height + Image5.top +15> Button4.Height+Button4.top+15 then
 GroupBox3.Height:=Image5.Height + Image5.top +15
else GroupBox3.Height:= Button4.Height+Button4.top+15;
GroupBox3.Width:=Image5.Width + Image5.left +15;
GroupBox3.Top:= GroupBox1.Height + GroupBox1.Top +10;

Form1.Width:= GroupBox1.Width+ GroupBox1.Left +15;
Form1.Height:= GroupBox3.Height+ GroupBox3.top +55;
end;

 PROCEDURE MinMax3(CONST i,j,k:  INTEGER; VAR min, max:  INTEGER);
  BEGIN
    IF   i > j
    THEN BEGIN
      IF   i > k
      THEN max := i
      ELSE max := k;

      IF   j < k
      THEN min := j
      ELSE min := k
    END
    ELSE BEGIN
      IF   j > k
      THEN max := j
      ELSE max := k;

      IF   i < k
      THEN min := i
      ELSE min := k
    END
  END {MinMax3};

 PROCEDURE RGBtoHSV (CONST r,g,b:  INTEGER;   {0..255}
                      VAR   h,s,v:  INTEGER);  {h IN 0..359; s,v IN 0..255}
    VAR
      Delta   :  INTEGER;
      MinValue:  INTEGER;
  BEGIN
    MinMax3(R, G, B, MinValue, v);
    Delta := v - MinValue;

    // Calculate saturation:  saturation is 0 if r, g and b are all 0
    IF   v = 0
    THEN s := 0
    ELSE s := (255 * Delta) DIV v;

    IF   s = 0
    THEN h := 0   // Achromatic:  When s = 0, h is undefined but assigned the value 0
    ELSE BEGIN    // Chromatic

      IF   r = v
      THEN h := (60*(g-b)) DIV Delta             // degrees -- between yellow and magenta
      ELSE
        IF   g = v
        THEN h := 120 + (60*(b-r)) DIV Delta     // degrees -- between cyan and yellow
        ELSE
          IF  b = v
          THEN h := 240 + (60*(r-g)) DIV Delta;  // degrees -- between magenta and cyan

      IF   h < 0
      THEN h := h + 360;

    END
  END {RGBtoHSV};

procedure TForm1.Button2Click(Sender: TObject);
VAR
   H,S,V    :  INTEGER;
   i        :  INTEGER;
   j        :  INTEGER;
   rowRGB   :  pRGBArray;
   rowH     :  pRGBArray;
BEGIN
    FOR   j := Image1.Picture.Bitmap.Height-1 DOWNTO 0 DO
    BEGIN
      rowRGB := Image1.Picture.Bitmap.Scanline[j];
      rowH   := Image2.Picture.Bitmap.Scanline[j];

      FOR i := Image1.Picture.Bitmap.Width-1 DOWNTO 0 DO
      BEGIN
        WITH rowRGB[i] DO
          RGBtoHSV(rgbtRed, rgbtGreen, rgbtBlue, H,S,V);

        // Use 24-bit bitmaps and assign RGB same values since only intensity is
        // important.  Seems like a pf8bit bitmap should work, but not for me.
        H := MulDiv(H, 255, 359);    // rescale from 0..359 to 0..255

        WITH rowH[i] DO
        BEGIN
          rgbtRed   := H;
          rgbtGreen := H;
          rgbtBlue  := H;
        END;

      END;
    END;
Image2.Repaint;
END;

procedure TForm1.Button3Click(Sender: TObject);
var x1,y1,x2,y2,x,y : integer;
    i,maxi:integer;
    c:TColor;
begin
image3.Canvas.FillRect(image3.canvas.cliprect);
image4.Canvas.FillRect(image4.canvas.cliprect);
x1:=0; y1:=0;
x2:=Image1.Picture.Bitmap.Width;
y2:=Image1.Picture.Bitmap.Height;
Image6.Picture.Bitmap.Assign(Image1.Picture.Bitmap);
Image6.Picture.Bitmap.Canvas.Pen.Color:=clLime;

bx:=-1; by:=-1;
// Vertical
maxi:=-1;
for y:=y1 to y2-1 do begin
 i:=0;
 for x:=x1 to x2 do begin
  c:=Image2.Canvas.Pixels[x,y];
  i:=i+(GetRValue(c)+GetGValue(c)+GetBValue(c)) div 3;
  end;
 if (y<y2) then begin
  i:=i div 100;
  if y=0 then begin
   image3.canvas.MoveTo(i,y);
   image6.canvas.MoveTo(i,y);
  end else begin
   image3.canvas.LineTo(i,y);
   image6.canvas.LineTo(i,y);
   end;
  end;
 if i>maxi then begin
  maxi:=i;
  by:=y;
  end;
 end;

//Horizontal
maxi:=-1;
for x:=x1 to x2-1 do begin
 i:=0;
 for y:=y1 to y2 do begin
  c:=Image2.Canvas.Pixels[x,y];
  i:=i+(GetRValue(c)+GetGValue(c)+GetBValue(c)) div 3;
  end;
 if (x<x2) then begin
  i:=i div 100;
  if x=0 then begin
   image4.canvas.MoveTo(x,y2-i);
   image6.canvas.MoveTo(x,y2- i);
  end else begin
   image4.canvas.LineTo(x,y2-i);
   image6.canvas.LineTo(x,y2-i);
   end;
  end;
 if i>maxi then begin
  maxi:=i;
  bx:=x;
  end;
 end;

// draw center and radius
shape1.left:=bx-10+image1.left;
shape1.top:=by-10+image1.top;
with image6.Canvas do begin
 Pen.Color:=clWhite;
 MoveTo(bx,by-2);
 LineTo(bx,by+2);

 MoveTo(bx-2,by);
 LineTo(bx+2,by);
 end;



//Image6.Picture.Bitmap.Assign(Image1.Picture.Bitmap);
//BitBlt(Image6.Picture.Bitmap.Handle,0,0,Image1.Picture.Bitmap.Width,Image1.Picture.Bitmap.Height,
// Image3.Picture.Bitmap.Handle,0,0,srcCopy);
//Image6.Picture.Bitmap.Canvas.Draw(0,0,Image3.Picture.Bitmap);

Image3.Repaint;
Image4.Repaint;
Image1.Repaint;
Image2.Repaint;
end;

function calcint(bt: TBitmap; x,y,r :integer) : integer;
var xx,yy,y1,y2,i,count,avarage:integer;
    c:TColor;
Begin
i:=-1; count:=0;
if y-r>0 then y1:=y-r else y1:=0;
if y+r>bt.width then y2:=bt.width-1 else y2:=y+r;

avarage:=-1; count:=0;
for yy:=y1 to y2 do
 for xx:=x-r to x+r do
  if sqrt(sqr(xx-x)+sqr(yy-y))<r then begin
   c:=bt.Canvas.Pixels[xx,yy];
   avarage:=avarage+ (GetRValue(c)+GetGValue(c)+GetBValue(c)) div 3;
   inc(count);
   end;

avarage:=avarage div count;
for yy:=y1 to y2 do
 for xx:=x-r to x+r do
  if sqrt(sqr(xx-x)+sqr(yy-y))<r then begin
   c:=bt.Canvas.Pixels[xx,yy];
   if (GetRValue(c)+GetGValue(c)+GetBValue(c)) div 3>=avarage then inc(i);
   //i:=i+ (GetRValue(c)+GetGValue(c)+GetBValue(c)) div 3;
   //inc(count);
   end;
//result:=i div count;
result:=i;
End;

Procedure Move(bt: TBitmap; r :integer);
var x,y,xx,yy,min:integer;
Begin
xx:=-1;
yy:=-1;
min:=calcint(bt,bx-10,by-10,r);
for x:=bx-8 to bx+8 do
 for y:=by-8 to by+8 do
  if calcint(bt,x,y,r)<min then begin
   //form1.image1.picture.bitmap.canvas.pixels[x,y]:=clLime;
   min:=calcint(bt,x,y,r);
   xx:=x;
   yy:=y;
   end;
bx:=xx;
by:=yy;
form1.image1.Repaint;
End;

Procedure MiddleFilter(source, dest: TBitmap);
type
    pRGBArray  =  ^TRGBArray;
    TRGBArray  =  ARRAY[0..32767] OF TRGBTriple;
var i, j: integer;
    Row1,Row2,Row3, DestRow: pRGBArray;
    b:byte;

    o1,o2:integer; // only median filter
    ba:array [0..8] of byte;
    s:byte;
begin
dest.Width:=source.Width;
dest.Height:=source.Height;
dest.PixelFormat:=pf24bit;
for i := 1 to source.Height - 2 do
 begin
 Row1 := source.ScanLine[i];
 Row2 := source.ScanLine[i-1];
 Row3 := source.ScanLine[i+1];
 DestRow := dest.ScanLine[i];
 for j := 1 to source.Width - 2 do
   begin
   //b:=(Row1[j].rgbtRed + Row1[j].rgbtGreen + Row1[j].rgbtBlue) div 3; // gray scale
   b:=(Row1[j].rgbtRed + Row1[j].rgbtGreen + Row1[j].rgbtBlue // middle filter
      +Row1[j-1].rgbtRed + Row1[j-1].rgbtGreen + Row1[j-1].rgbtBlue
      +Row1[j+1].rgbtRed + Row1[j+1].rgbtGreen + Row1[j+1].rgbtBlue
      +
       Row2[j].rgbtRed + Row2[j].rgbtGreen + Row2[j].rgbtBlue
      +Row2[j-1].rgbtRed + Row2[j-1].rgbtGreen + Row2[j-1].rgbtBlue
      +Row2[j+1].rgbtRed + Row2[j+1].rgbtGreen + Row2[j+1].rgbtBlue
      +
       Row3[j].rgbtRed + Row3[j].rgbtGreen + Row3[j].rgbtBlue
      +Row3[j-1].rgbtRed + Row3[j-1].rgbtGreen + Row3[j-1].rgbtBlue
      +Row3[j+1].rgbtRed + Row3[j+1].rgbtGreen + Row3[j+1].rgbtBlue) div 27;


   (*ba[0]:=(Row1[j].rgbtRed + Row1[j].rgbtGreen + Row1[j].rgbtBlue) div 3;  //median
   ba[1]:=(Row1[j-1].rgbtRed + Row1[j-1].rgbtGreen + Row1[j-1].rgbtBlue) div 3;
   ba[2]:=(Row1[j+1].rgbtRed + Row1[j+1].rgbtGreen + Row1[j+1].rgbtBlue) div 3;
   ba[3]:=(Row2[j].rgbtRed + Row2[j].rgbtGreen + Row2[j].rgbtBlue) div 3;
   ba[4]:=(Row2[j-1].rgbtRed + Row2[j-1].rgbtGreen + Row2[j-1].rgbtBlue) div 3;
   ba[5]:=(Row2[j+1].rgbtRed + Row2[j+1].rgbtGreen + Row2[j+1].rgbtBlue) div 3;
   ba[6]:=(Row3[j].rgbtRed + Row3[j].rgbtGreen + Row3[j].rgbtBlue) div 3;
   ba[7]:=(Row3[j-1].rgbtRed + Row3[j-1].rgbtGreen + Row3[j-1].rgbtBlue) div 3;
   ba[8]:=(Row3[j+1].rgbtRed + Row3[j+1].rgbtGreen + Row3[j+1].rgbtBlue) div 3;

   // sort
   for o1:=0 to 8 do
    for o2:=o1+1 to 8 do
     if ba[o2]<ba[o1] then begin s:=ba[o1]; ba[o1]:=ba[o2]; ba[o2]:=s; end;
   b:=ba[4];*)

   DestRow[j].rgbtRed:=b;
   DestRow[j].rgbtGreen:=b;
   DestRow[j].rgbtBlue:=b;
   end;
 end;
End;

procedure TForm1.Button4Click(Sender: TObject);
var act,r,ri:integer;
begin
r:=10;

memo1.clear;
(*memo1.Lines.Add(inttostr(bx)+','+inttostr(by)+': '+inttostr(
 calcint(image1.picture.bitmap,bx,by,r) ));

memo1.Lines.Add(inttostr(bx-1)+','+inttostr(by)+': '+inttostr(
 calcint(image1.picture.bitmap,bx-1,by,r) ));

memo1.Lines.Add(inttostr(bx+1)+','+inttostr(by)+': '+inttostr(
 calcint(image1.picture.bitmap,bx+1,by,r) ));  *)



move(image5.picture.bitmap,r);
(*act:=calcint(image1.picture.bitmap,bx,by,r);
if calcint(image1.picture.bitmap,bx-1,by,r)<act then begin
 bx:=bx-1;
 act:=calcint(image1.picture.bitmap,bx,by,r);
 end;
if calcint(image1.picture.bitmap,bx+1,by,r)<act then begin
 bx:=bx+1;
 act:=calcint(image1.picture.bitmap,bx,by,r);
 end;

if calcint(image1.picture.bitmap,bx,by-1,r)<act then begin
 by:=by-1;
 act:=calcint(image1.picture.bitmap,bx,by,r);
 end;
if calcint(image1.picture.bitmap,bx,by+1,r)<act then begin
 by:=by+1;
 act:=calcint(image1.picture.bitmap,bx,by,r);
 end;*)

for ri:=r to 30 do begin
 memo1.Lines.Add(inttostr(ri)+': '+inttostr(
   calcint(image5.picture.bitmap,bx,by,ri) ));
 if calcint(image5.picture.bitmap,bx,by,ri)<=450 then begin
  r:=ri;
  act:=calcint(image5.picture.bitmap,bx,by,r);
  end;
 end;

form1.Caption:=inttostr(r);
shape2.left:=bx-r+image1.left;
shape2.top:=by-r+image1.top;
shape2.Width:=r*2;
shape2.Height:=r*2;
end;


procedure TForm1.Button5Click(Sender: TObject);
begin
MiddleFilter(Image1.Picture.Bitmap,Image5.Picture.Bitmap);
Image5.Repaint;
end;

Procedure MoveComponent(Sender:TObject; Shift: TShiftState; x,y:integer);
begin
if (ssleft in shift) then
        begin
        if mg=false then begin mg:=true; mx:=x; my:=y; end;
        TControl(Sender).left:=TControl(Sender).left+x-mx;
        TControl(Sender).top:=TControl(Sender).top+y-my;
        end;
if (not(ssleft in shift))and(mg) then mg:=false;
end;

procedure TForm1.GroupBox2MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
MoveComponent(Sender,Shift,x,y);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
MiddleFilter(Image5.Picture.Bitmap,Image5.Picture.Bitmap);
Image5.Repaint;
end;

end.
